unit AnalogKonfig;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Spin, ExtCtrls, IniFiles;

type
  TAnalogKonfigForm = class(TForm)
    RahmenBevel: TBevel;
    NameEdit: TEdit;
    CANIDEdit: TEdit;
    EinheitEdit: TEdit;
    BerechnungsTermEdit: TEdit;
    SkalaGroup: TGroupBox;
    MinSkalaSpin: TSpinEdit;
    MaxSkalaSpin: TSpinEdit;
    SkalaUnterteilungSpin: TSpinEdit;
    SkalaTeilungSpin: TSpinEdit;
    FaktorSpin: TSpinEdit;
    OKBtn: TBitBtn;
    AbbrechenBtn: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Teilung2Label: TLabel;
    Teilung1Label: TLabel;
    Label9: TLabel;
    LadenBtn: TBitBtn;
    SpeichernBtn: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CANIDEditChange(Sender: TObject);
    procedure CANIDEditEnter(Sender: TObject);
    procedure CANIDEditExit(Sender: TObject);
    procedure LadenBtnClick(Sender: TObject);
    procedure SpeichernBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
    Dateiname: string;
  public
    { Public-Deklarationen }
  end;

implementation

uses Hauptfenster, IntegerTerm;

{$R *.dfm}

procedure TAnalogKonfigForm.FormCreate(Sender: TObject);
begin
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(0, OKBtn.Glyph);
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(1, AbbrechenBtn.Glyph);
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(5, LadenBtn.Glyph);
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(4, SpeichernBtn.Glyph);
end;

procedure TAnalogKonfigForm.OKBtnClick(Sender: TObject);
var
  i, fs, fl: integer;
  BerechnungsObj: TIntTerm;
  Varis: VarArray;
begin
  BerechnungsObj := TIntTerm.Create;

  Dateiname := '';

  SetLength(Varis, 8);
  for i := 0 to high(Varis) do
  begin
    Varis[i].Name := format('d%u',[i]);
    Varis[i].Wert := 0;
  end;

  try
    BerechnungsObj.TermLoesen(BerechnungsTermEdit.Text, @Varis);
  except
    MessageDlg('Im Berechnungs Term ist ein Fehler aufgetretten:'+#13+#10+
          BerechnungsObj.GetFehlerText, mtError, [mbOk], 0);
    BerechnungsObj.GetFehler(@fs, @fl);
    BerechnungsTermEdit.SetFocus;
    BerechnungsTermEdit.SelStart := fs-1;
    BerechnungsTermEdit.SelLength := fl;
    BerechnungsObj.Free;
    exit;
  end;
  BerechnungsObj.Free;
  ModalResult := mrOK;
end;

procedure TAnalogKonfigForm.CANIDEditChange(Sender: TObject);
begin
  TMainForm(Owner.Owner).CheckZahlenTEditEingabe(TEdit(Sender), TMainForm(Owner.Owner).MaxID);
end;

procedure TAnalogKonfigForm.CANIDEditEnter(Sender: TObject);
begin
  TEdit(Sender).Text := TMainForm(Owner.Owner).GetIDString(TEdit(Sender).Tag);
end;

procedure TAnalogKonfigForm.CANIDEditExit(Sender: TObject);
begin
  TMainForm(Owner.Owner).HexEditViewValue(Sender);
end;

procedure TAnalogKonfigForm.LadenBtnClick(Sender: TObject);
var
  IniDatei: TIniFile;
begin
  TMainForm(Owner.Owner).OpenDialog.Title := 'Instrumenten-Einstellungen laden';
  TMainForm(Owner.Owner).OpenDialog.DefaultExt := 'cin';
  TMainForm(Owner.Owner).OpenDialog.Filter := 'Instrument (*.cin)|*.cin|Alle Dateien (*.*)|*.*';

  if TMainForm(Owner.Owner).OpenDialog.Execute then
  begin
    IniDatei := TIniFile.Create(TMainForm(Owner.Owner).OpenDialog.FileName);
    try
      NameEdit.Text := IniDatei.ReadString('Allgemein', 'Name', TMainForm(Owner.Owner).OpenDialog.FileName);
      Dateiname := NameEdit.Text;
      CANIDEdit.Tag := IniDatei.ReadInteger('Allgemein', 'CanID', 0);
      CANIDEdit.Text := TMainForm(Owner.Owner).GetIDString(CANIDEdit.Tag);
      BerechnungsTermEdit.Text := IniDatei.ReadString('Allgemein', 'Term', 'd0');
      EinheitEdit.Text := IniDatei.ReadString('Instrument', 'Einheit', 'Einheit');
      MinSkalaSpin.Value := IniDatei.ReadInteger('Instrument', 'MinSkala', 0);
      MaxSkalaSpin.Value := IniDatei.ReadInteger('Instrument', 'MaxSkala', 1000);
      SkalaTeilungSpin.Value := IniDatei.ReadInteger('Instrument', 'SkalenTeilung', 11);
      SkalaUnterteilungSpin.Value := IniDatei.ReadInteger('Instrument', 'SkalenUnterTeilung', 5);
      FaktorSpin.Value := IniDatei.ReadInteger('Instrument', 'Faktor', 1);
    finally
      IniDatei.Free;
    end;
  end;
end;

procedure TAnalogKonfigForm.SpeichernBtnClick(Sender: TObject);
var
  IniDatei: TIniFile;
begin
  TMainForm(Owner.Owner).SaveDialog.Title := 'Instrumenten-Einstellungen speichern';
  TMainForm(Owner.Owner).SaveDialog.DefaultExt := 'cin';
  if Dateiname = '' then
    TMainForm(Owner.Owner).SaveDialog.FileName := NameEdit.Text + '.cin'
  else
    TMainForm(Owner.Owner).SaveDialog.FileName := Dateiname;
  TMainForm(Owner.Owner).SaveDialog.Filter := 'Instrument (*.cin)|*.cin|Alle Dateien (*.*)|*.*';

  if TMainForm(Owner.Owner).SaveDialog.Execute then
  begin
    Dateiname := TMainForm(Owner.Owner).SaveDialog.FileName;
    IniDatei := TIniFile.Create(TMainForm(Owner.Owner).SaveDialog.FileName);
    try
      IniDatei.WriteString('Allgemein', 'Typ', Owner.ClassName);
      IniDatei.WriteString('Allgemein', 'Name', NameEdit.Text);
      IniDatei.WriteInteger('Allgemein', 'CanID', CANIDEdit.Tag);
      IniDatei.WriteString('Allgemein', 'Term', BerechnungsTermEdit.Text);
      IniDatei.WriteString('Instrument', 'Einheit', EinheitEdit.Text);
      IniDatei.WriteInteger('Instrument', 'MinSkala', MinSkalaSpin.Value);
      IniDatei.WriteInteger('Instrument', 'MaxSkala', MaxSkalaSpin.Value);
      IniDatei.WriteInteger('Instrument', 'SkalenTeilung', SkalaTeilungSpin.Value);
      IniDatei.WriteInteger('Instrument', 'SkalenUnterTeilung', SkalaUnterteilungSpin.Value);
      IniDatei.WriteInteger('Instrument', 'Faktor', FaktorSpin.Value);
    finally
      IniDatei.Free;
    end;
  end;
end;

end.
