unit BitIndikatorKonfig;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Buttons, ExtCtrls, IniFiles, StrUtils;

type
  TBitKonfigForm = class(TForm)
    RahmenBevel: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label9: TLabel;
    CANIDEdit: TEdit;
    BerechnungsTermEdit: TEdit;
    OKBtn: TBitBtn;
    AbbrechenBtn: TBitBtn;
    NameEdit: TEdit;
    LadenBtn: TBitBtn;
    SpeichernBtn: TBitBtn;
    BitNameGrid: TStringGrid;
    HinzufuegenBtn: TBitBtn;
    Bevel1: TBevel;
    Label3: TLabel;
    EntfernenBtn: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure LadenBtnClick(Sender: TObject);
    procedure SpeichernBtnClick(Sender: TObject);
    procedure CANIDEditChange(Sender: TObject);
    procedure CANIDEditEnter(Sender: TObject);
    procedure CANIDEditExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure HinzufuegenBtnClick(Sender: TObject);
    procedure EntfernenBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
    Dateiname: string;
  public
    { Public-Deklarationen }
  end;

implementation

uses Hauptfenster, IntegerTerm;

{$R *.dfm}

procedure TBitKonfigForm.FormCreate(Sender: TObject);
begin
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(0, OKBtn.Glyph);
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(1, AbbrechenBtn.Glyph);
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(5, LadenBtn.Glyph);
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(4, SpeichernBtn.Glyph);
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(2, HinzufuegenBtn.Glyph);
  TMainForm(Owner.Owner).ButtonImages.GetBitmap(3, EntfernenBtn.Glyph);

  BitNameGrid.ColWidths[1] := 125;
  BitNameGrid.Cells[1, 0] := 'Bit Bezeichnung';
end;

procedure TBitKonfigForm.FormShow(Sender: TObject);
var
  i: integer;
begin
  for i := 1 to BitNameGrid.RowCount-1 do
    BitNameGrid.Cells[0, i] := format('Bit %u',[i-1]);
end;

procedure TBitKonfigForm.HinzufuegenBtnClick(Sender: TObject);
begin
  if  BitNameGrid.RowCount < 18 then
  begin
    BitNameGrid.RowCount := BitNameGrid.RowCount + 1;
    BitNameGrid.Cells[0, BitNameGrid.RowCount - 1] := format('Bit %u',[BitNameGrid.RowCount-2]);
  end;
end;

procedure TBitKonfigForm.EntfernenBtnClick(Sender: TObject);
begin
  if BitNameGrid.RowCount > 2 then
    BitNameGrid.RowCount := BitNameGrid.RowCount - 1;
end;

procedure TBitKonfigForm.CANIDEditChange(Sender: TObject);
begin
  TMainForm(Owner.Owner).CheckZahlenTEditEingabe(TEdit(Sender), TMainForm(Owner.Owner).MaxID);
end;

procedure TBitKonfigForm.CANIDEditEnter(Sender: TObject);
begin
  TEdit(Sender).Text := TMainForm(Owner.Owner).GetIDString(TEdit(Sender).Tag);
end;

procedure TBitKonfigForm.CANIDEditExit(Sender: TObject);
begin
  TMainForm(Owner.Owner).HexEditViewValue(Sender);
end;

procedure TBitKonfigForm.OKBtnClick(Sender: TObject);
var
  i, fs, fl: integer;
  BerechnungsObj: TIntTerm;
  Varis: VarArray;
begin
  BerechnungsObj := TIntTerm.Create;

  Dateiname := '';

  SetLength(Varis, 8);
  for i := 0 to high(Varis) do
  begin
    Varis[i].Name := format('d%u',[i]);
    Varis[i].Wert := 0;
  end;

  try
    BerechnungsObj.TermLoesen(BerechnungsTermEdit.Text, @Varis);
  except
    MessageDlg('Im Berechnungs Term ist ein Fehler aufgetretten:'+#13+#10+
          BerechnungsObj.GetFehlerText, mtError, [mbOk], 0);
    BerechnungsObj.GetFehler(@fs, @fl);
    BerechnungsTermEdit.SetFocus;
    BerechnungsTermEdit.SelStart := fs-1;
    BerechnungsTermEdit.SelLength := fl;
    BerechnungsObj.Free;
    exit;
  end;
  BerechnungsObj.Free;
  ModalResult := mrOK;
end;

procedure TBitKonfigForm.LadenBtnClick(Sender: TObject);
var
  i, n: integer;
  IniDatei: TIniFile;
  BitListe: TStrings;
begin
  TMainForm(Owner.Owner).OpenDialog.Title := 'Instrumenten-Einstellungen laden';
  TMainForm(Owner.Owner).OpenDialog.DefaultExt := 'cin';
  TMainForm(Owner.Owner).OpenDialog.Filter := 'Instrument (*.cin)|*.cin|Alle Dateien (*.*)|*.*';

  if TMainForm(Owner.Owner).OpenDialog.Execute then
  begin
    IniDatei := TIniFile.Create(TMainForm(Owner.Owner).OpenDialog.FileName);
    try
      NameEdit.Text := IniDatei.ReadString('Allgemein', 'Name', TMainForm(Owner.Owner).OpenDialog.FileName);
      Dateiname := NameEdit.Text;
      CANIDEdit.Tag := IniDatei.ReadInteger('Allgemein', 'CanID', 0);
      CANIDEdit.Text := TMainForm(Owner.Owner).GetIDString(CANIDEdit.Tag);
      BerechnungsTermEdit.Text := IniDatei.ReadString('Allgemein', 'Term', 'd0');

      BitListe := TStringList.Create;
      IniDatei.ReadSection('BitIndikator', BitListe);
      BitNameGrid.RowCount := 2;
      BitNameGrid.Cells[1, 1] := '';
      for i := 0 to BitListe.Count-1 do
      begin
        if AnsiStartsText('Bit', BitListe.Strings[i]) then
        begin
          n := StrToInt(copy(BitListe.Strings[i], 4, 4));
          while (n >= BitNameGrid.RowCount - 1) do
            BitNameGrid.RowCount := BitNameGrid.RowCount + 1;
          BitNameGrid.Cells[1, n+1] := IniDatei.ReadString('BitIndikator',
                BitListe.Strings[i], BitNameGrid.Cells[1, n+1]);
        end;
      end;
      BitListe.Free;

      FormShow(self);
    finally
      IniDatei.Free;
    end;
  end;
end;

procedure TBitKonfigForm.SpeichernBtnClick(Sender: TObject);
var
  i: integer;
  IniDatei: TIniFile;
begin
  TMainForm(Owner.Owner).SaveDialog.Title := 'Instrumenten-Einstellungen speichern';
  TMainForm(Owner.Owner).SaveDialog.DefaultExt := 'cin';
  if Dateiname = '' then
    TMainForm(Owner.Owner).SaveDialog.FileName := NameEdit.Text + '.cin'
  else
    TMainForm(Owner.Owner).SaveDialog.FileName := Dateiname;
  TMainForm(Owner.Owner).SaveDialog.Filter := 'Instrument (*.cin)|*.cin|Alle Dateien (*.*)|*.*';

  if TMainForm(Owner.Owner).SaveDialog.Execute then
  begin
    Dateiname := TMainForm(Owner.Owner).SaveDialog.FileName;
    IniDatei := TIniFile.Create(TMainForm(Owner.Owner).SaveDialog.FileName);
    try
      IniDatei.WriteString('Allgemein', 'Name', NameEdit.Text);
      IniDatei.WriteInteger('Allgemein', 'CanID', CANIDEdit.Tag);
      IniDatei.WriteString('Allgemein', 'Term', BerechnungsTermEdit.Text);
      for i := 1 to BitNameGrid.RowCount-1 do
        IniDatei.WriteString('BitIndikator', format('Bit%u', [i - 1]), BitNameGrid.Cells[1, i]);
    finally
      IniDatei.Free;
    end;

  end;
end;

end.
