unit Hauptfenster;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, Menus, ComCtrls, IniFiles, StdCtrls, ExtCtrls, Buttons,
  ToolWin, Grids, StrUtils, ImgList, FTDI;

const
  USBBaudRate = 625000;
  RxBufferSize = 8192;
  SlotNum = 15;

  WM_DONGLERESETACKN = WM_USER + 0;
  WM_DONGLECANERROR = WM_USER + 1;
  WM_DONGLERXDATA = WM_USER + 2;
  WM_SENDETIMER = WM_USER + 10;

type
  TNumBase = (nbNone, nbDezimal, nbHexadezimal, nbBinaer);

  TCANrecord = record
    ID: dword;
    Timestamp: dword;
    Cmd: byte;
    DLC: byte;
    Data: array[0..7] of byte;
    MsgAnzahl: dword;        // Dient zum errechnen des Intervals
    IntervalSumme: dword;    // Dient zum errechnen des Intervals
  end;
  PCANrecord = ^TCANrecord;

  TCANBaudParam = record
    Name: string;
    c0conrl: byte;
    c0conrh: byte;
    cclkr: byte;
  end;

  TSlotInfo = record
    ID: dword;
    Flags: Byte;  // Bit0/1 - Rx/Tx aktiv
                  // Bit2 - Remote
                  // Bit7 - FehlerhafterDatensatz
  end;
  PSlotInfo = ^TSlotInfo;

  TComThread = class;

  TMainForm = class(TForm)
    HauptMenu: TMainMenu;
    DateiMnu: TMenuItem;
    HilfeMnu: TMenuItem;
    Info1: TMenuItem;
    BeendenMnu: TMenuItem;
    ActionList: TActionList;
    EinstellungenMnu: TMenuItem;
    N1: TMenuItem;
    actEinstellungen: TAction;
    actBeenden: TAction;
    actInfo: TAction;
    SchnittstelleffnenMnu: TMenuItem;
    N2: TMenuItem;
    actVerbinden: TAction;
    SlotPanel: TPanel;
    StatusBar: TStatusBar;
    Slot0_13Group: TGroupBox;
    SlotGrid: TStringGrid;
    Slot14Group: TGroupBox;
    Label5: TLabel;
    AnsichtMnu: TMenuItem;
    FensterMnu: TMenuItem;
    DezIDMnu: TMenuItem;
    actDezID: TAction;
    actHexID: TAction;
    actBinID: TAction;
    HexIDMnu: TMenuItem;
    CheckerImages: TImageList;
    CANTimeOut: TTimer;
    N3: TMenuItem;
    EmpfangsFensterMnu: TMenuItem;
    SendenFensterMnu: TMenuItem;
    ProtokollMnu: TMenuItem;
    actEmpfangsFenster: TAction;
    actSendeFenster: TAction;
    actProtokoll: TAction;
    StandardIDMnu: TMenuItem;
    ErweiterteIDMnu: TMenuItem;
    N4: TMenuItem;
    actStandardID: TAction;
    actErweiterteID: TAction;
    ButtonImages: TImageList;
    CANControllerMnu: TMenuItem;
    DezDatenMnu: TMenuItem;
    HexDatenMnu: TMenuItem;
    BinDatenMnu: TMenuItem;
    actDezDaten: TAction;
    actHexDaten: TAction;
    actBinDaten: TAction;
    USBImages: TImageList;
    Label2: TLabel;
    Mask0Edit: TEdit;
    Mask14Edit: TEdit;
    SaveDialog: TSaveDialog;
    N5: TMenuItem;
    ResetMnu: TMenuItem;
    SlotsResetMnu: TMenuItem;
    actSlotReset: TAction;
    actFirmwareUpdate: TAction;
    FirmwareUpdateMnu: TMenuItem;
    OpenDialog: TOpenDialog;
    actZaehlerReset: TAction;
    ZaehlerResetMnu: TMenuItem;
    ToolBar: TToolBar;
    VerindenToolBtn: TToolButton;
    ToolImageList: TImageList;
    ToolButton2: TToolButton;
    actAnalogInstrumentFenster: TAction;
    AnalogInstrumentMnu: TMenuItem;
    actOszillogrammFenster: TAction;
    OszilogrammMnu: TMenuItem;
    actWertAnzeigeFenster: TAction;
    actBitIndikatorFenster: TAction;
    WertAnzeigeMnu: TMenuItem;
    BitIndikatorMnu: TMenuItem;
    actNextMDI: TAction;
    actPrevMDI: TAction;
    NextMDIMnu: TMenuItem;
    PrevMDIMnu: TMenuItem;
    N6: TMenuItem;
    actInstrumentOeffnen: TAction;
    OeffnenMnu: TMenuItem;
    N7: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    DongleListPopup: TPopupMenu;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure actEinstellungenExecute(Sender: TObject);
    procedure actBeendenExecute(Sender: TObject);
    procedure actInfoExecute(Sender: TObject);
    procedure actVerbindenExecute(Sender: TObject);
    procedure actEmpfangsFensterExecute(Sender: TObject);
    procedure actSendeFensterExecute(Sender: TObject);
    procedure actStandardIDExecute(Sender: TObject);
    procedure actErweiterteIDExecute(Sender: TObject);
    procedure actProtokollExecute(Sender: TObject);
    procedure actDezIDExecute(Sender: TObject);
    procedure actHexIDExecute(Sender: TObject);
    procedure actBinIDExecute(Sender: TObject);
    procedure actDezDatenExecute(Sender: TObject);
    procedure actHexDatenExecute(Sender: TObject);
    procedure actBinDatenExecute(Sender: TObject);
    procedure SlotGridDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure SlotGridGetEditText(Sender: TObject; ACol, ARow: Integer; var Value: String);
    procedure SlotGridSelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
    procedure SlotGridKeyPress(Sender: TObject; var Key: Char);
    procedure SlotGridMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SlotGridSetEditText(Sender: TObject; ACol, ARow: Integer; const Value: String);
    procedure SlotGridExit(Sender: TObject);
    procedure HexEditKeyPress(Sender: TObject; var Key: Char);
    procedure HexEditChange(Sender: TObject);
    procedure HexEditViewValue(Sender: TObject);
    procedure HexEditConfirm(Sender: TObject);
    procedure CANTimeOutTimer(Sender: TObject);
    procedure StatusBarDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
    procedure FormShow(Sender: TObject);
    procedure actSlotResetExecute(Sender: TObject);
    procedure actFirmwareUpdateExecute(Sender: TObject);
    procedure actZaehlerResetExecute(Sender: TObject);
    procedure actAnalogInstrumentFensterExecute(Sender: TObject);
    procedure actOszillogrammFensterExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure actWertAnzeigeFensterExecute(Sender: TObject);
    procedure actBitIndikatorFensterExecute(Sender: TObject);
    procedure actNextMDIExecute(Sender: TObject);
    procedure actPrevMDIExecute(Sender: TObject);
    procedure actInstrumentOeffnenExecute(Sender: TObject);
    procedure ProtokollAddLine(s: string);
    procedure DongleListPopupPopup(Sender: TObject);
    procedure OnPopupMenuItemClick(Sender: TObject);
  private
    { Private-Deklarationen }
    LizenzAnzeige: boolean;
    VerbindungsStat: integer;   // Marker fr Iconanzeige in der Statusbar

    RxNachrichtenCount: integer;
    TxNachrichtenCount: integer;
    RxFehler: integer;
    TxFehler: integer;
    PufferAktuell: integer;
    PufferMax: integer;

    DongleSerNr: string;
    ComThread: TComThread;
    hDongle: THandle;
    hDongleRxEvent: THandle;
    DongleActive: boolean;
    procedure OnDongleResetAckn(var Msg:TMessage);message WM_DONGLERESETACKN;
    procedure OnDongleCANError(var Msg:TMessage);message WM_DONGLECANERROR;
    procedure OnDongleRx(var Msg:TMessage);message WM_DONGLERXDATA;
    procedure OnThreadTextMsg(s: string);

    function Verbinden(): integer;
    procedure Trennen();
    procedure CANReset();
    procedure IniAllSlots();
    procedure SendSlotIDs(SlotNr: integer);
    procedure RefreshPanel();
    procedure RefreshMDIClients();
    procedure RefreshStatusBar();
    function  MDIClientOeffnen(ClientForm: TFormClass): TForm;
  public
    { Public-Deklarationen }
    CANEingangsListe: TThreadList;

    SlotList: TList;
    IDLaenge: integer;
    MaxID: dword;

    CANBaudIdx: integer;
    ListenOnlyAktiv: boolean;
    LoopBackAktiv: boolean;
    RxRefreshRate: integer;
    ASCIISpalteAktiv: boolean;

    ProtokollForm: TForm;
    EmpfangDatei: string;
    SendenDatei: string;

    function  MenuMDIClientHinzufuegen(Sender: TForm): TMenuItem;
    procedure MenuMDIClientEntfernen(MenuItem: TMenuItem);
    procedure SendCommand(Data:PByte; Size:Cardinal);
    function  GetIDString(ID: dword): string;
    function  GetDataString(Data: dword): string;
    function  CheckZahlenEingabe(NumString: string; var Value: dword; MaxValue: dword): integer; overload;
    function  CheckZahlenEingabe(NumString: string; var Value: word; MaxValue: dword): integer; overload;
    function  CheckZahlenEingabe(NumString: string; var Value: byte; MaxValue: dword): integer; overload;
    function  CheckZahlenTEditEingabe(Sender: TEdit; MaxValue: dword): integer;
    procedure IncTxZaehler();

    procedure GetDeviceList();
  end;

  TComThread = class(TThread)
  private
    Owner: TMainForm;
    hOwner: THandle;
    hRxEvent: THandle;

    TextNachricht: string;
    err: integer;
    RxBuffer: array[0..RxBufferSize-1] of byte;
    RxByteInQueue: integer;
    RxBytes: integer;

    procedure SetName;
    procedure SendeTextNachricht;
    procedure GetQueueStatus;
    procedure ReadQueue;
  protected
    procedure Execute; override;
  public
    hDongle: THandle;
    constructor Create(AOwner: TMainForm); //override;
  end;

  TThreadNameInfo = record
    FType: dword;     // muss 0x1000 sein
    FName: PChar;        // Zeiger auf Name (in Anwender-Adress-Bereich)
    FThreadID: dword; // Thread-ID (-1 ist Caller-Thread)
    FFlags: dword;    // reserviert fr zuknftige Verwendung, muss 0 sein
  end;

const
  STARTTAG = $aa;
  ENDTAG = $a5;
  RESETCMD = $20;
  MASK0CMD = $21;
  MASK14CMD = $22;
  MASK15CMD = $23;
  CANMSGDISABLE = $c0;
  CANMSGSEND = $80;
  CANMSGEMPGANG = $40;
  CANERROR = $2f;

  SlotStatImage: array [0..3] of integer = (0,3,2,4);

  //                     f1
  // Baud = -------------------------------
  //         2 * fcan-div * prescaler * Tq

  //  8Tq - SS=1, PTS=3, PBS1=2, PBS2=2
  // 10Tq - SS=1, PTS=3, PBS1=3, PBS2=3
  // 16Tq - SS=1, PTS=7, PBS1=4, PBS2=4
  // 20Tq - SS=1, PTS=7, PBS1=6, PBS2=6
  // 25Tq - SS=1, PTS=8, PBS1=8, PBS2=8

  CANBaudParameter: array [0..10] of TCANBaudParam =
       ((Name:  '10kBps'; c0conrl:$e9; c0conrh:$3f; cclkr:$03),   // 1:40, 25Tq
        (Name:  '20kBps'; c0conrl:$e9; c0conrh:$3f; cclkr:$01),   // 1:20, 25Tq
        (Name:'33.3kBps'; c0conrl:$ce; c0conrh:$2d; cclkr:$00),   // 1:15, 20Tq
        (Name:  '50kBps'; c0conrl:$c9; c0conrh:$2d; cclkr:$00),   // 1:10, 20Tq
        (Name:'62.5kBps'; c0conrl:$c7; c0conrh:$2d; cclkr:$00),   // 1:8, 20Tq
        (Name:'83.3kBps'; c0conrl:$c5; c0conrh:$2d; cclkr:$00),   // 1:6, 20Tq
        (Name: '100kBps'; c0conrl:$c4; c0conrh:$2d; cclkr:$00),   // 1:5, 20Tq
        (Name: '125kBps'; c0conrl:$c3; c0conrh:$2d; cclkr:$00),   // 1:4, 20Tq
        (Name: '250kBps'; c0conrl:$c1; c0conrh:$2d; cclkr:$00),   // 1:2, 20Tq
        (Name: '500kBps'; c0conrl:$c0; c0conrh:$2d; cclkr:$00),   // 1:1, 20Tq
        (Name: '  1MBps'; c0conrl:$40; c0conrh:$12; cclkr:$00));  // 1:1, 10Tq

var
  MainForm: TMainForm;

{ Globale Funktionen }

function SwapBytes(Value: dword): dword;
procedure SwapBytesP(Value: pdword);
procedure SwapBytesC(Value: dword; Ziel: pdword);
function ReadListInteger(Liste: TStrings; Name: string; Standard: integer): integer;
function ReadListString(Liste: TStrings; Name: string; Standard: string): string;

implementation

{$R *.dfm}

uses
  Einstellungen, Info, Empfang, Senden, Protokoll, Firmware,
  EmpfangPrototyp, AnalogInstrument, Oszillogramm, WertAnzeige, BitIndikator;

function SwapBytes(Value: dword): dword;
asm
  bswap eax;
end;

procedure SwapBytesP(Value: pdword);
asm
  mov edx,[eax];
  bswap edx;
  mov [eax],edx;
end;

procedure SwapBytesC(Value: dword; Ziel: pdword);
asm
  bswap eax;
  mov [edx],eax;
end;

function ReadListInteger(Liste: TStrings; Name: string; Standard: integer): integer;
var
  s: string;
begin
  s := Liste.Values[Name];
  if s <> '' then
  begin
    try
      result := StrToInt(s);
    except
      result := Standard;
    end;
  end
  else
    result := Standard;
end;

function ReadListString(Liste: TStrings; Name: string; Standard: string): string;
begin
  result := Liste.Values[Name];
  if result = '' then
    result := Standard;
end;

{ TMainForm }

procedure TMainForm.FormCreate(Sender: TObject);
var
  IniDatei: TIniFile;
  i: integer;
  PSlot: ^TSlotInfo;
  InfoForm: TInfoForm;
begin
//  SetPriorityClass(GetCurrentProcess, $8000); // entspricht ABOVE_NORMAL_PRIORITY_CLASS
//  SetPriorityClass(GetCurrentProcess, HIGH_PRIORITY_CLASS);

  ProtokollForm := nil;

  VerbindungsStat := 0;

  RxNachrichtenCount := 0;
  TxNachrichtenCount := 0;
  RxFehler := 0;
  TxFehler := 0;
  StatusBar.Font.Style := [];
  RefreshStatusBar;

  actHexID.Execute;
  actStandardID.Execute;

  SlotGrid.Hint := 'ID - Idenifier'+#13+
                   '<-> - Datenrichtung'+#13+
                   'Rm - Remote'+#13+
                   'Status - aktueller Status';
  SlotGrid.RowCount := SlotNum + 1;

  hDongle := 0;
  hDongleRxEvent := CreateEvent(nil,True,False,'');
  CANEingangsListe := TThreadList.Create;
  ComThread := TComThread.Create(self);   // Wird nicht sofort gestartet
  DongleActive := false;

  IniDatei := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini') );
  try
    LizenzAnzeige := IniDatei.ReadBool('Allgemein', 'Lizenz', true);
    DongleSerNr := IniDatei.ReadString('Allgemein', 'DongleSerienNr', '');
    CANBaudIdx := IniDatei.ReadInteger('CAN', 'BaudIdx', 3);
    ListenOnlyAktiv := IniDatei.ReadBool('CAN', 'ListenOnly', true);
    LoopBackAktiv := IniDatei.ReadBool('CAN', 'LoopBack', false);
    RxRefreshRate := IniDatei.ReadInteger('Allgemein', 'RxRefresh', 0);
    ASCIISpalteAktiv := IniDatei.ReadBool('Allgemein', 'RxASCIIAnzeige', false);

    Left := IniDatei.ReadInteger('AppliFenster', 'XPos', 0);
    Top := IniDatei.ReadInteger('AppliFenster', 'YPos', 0);
    Width := IniDatei.ReadInteger('AppliFenster', 'Breite', 0);
    Height := IniDatei.ReadInteger('AppliFenster', 'Hoehe', 0);

    Mask0Edit.Tag := IniDatei.ReadInteger('SlotDaten', 'Maske0', MaxID);
    Mask14Edit.Tag := IniDatei.ReadInteger('SlotDaten', 'Maske14', 0);
    HexEditViewValue(Mask0Edit);
    HexEditViewValue(Mask14Edit);

    SlotList := TList.Create;
    for i := 0 to SlotNum-1 do
    begin
      new(PSlot);
      PSlot.ID := IniDatei.ReadInteger('SlotDaten', 'Slot'+IntToStr(i)+'ID', 0);
      PSlot.Flags := IniDatei.ReadInteger('SlotDaten', 'Slot'+IntToStr(i)+'Flags', 0);
      if (PSlot.Flags and $03) <> $01 then
        PSlot.Flags := $00;
      SlotList.Add(PSlot);
    end;
  finally
    IniDatei.Free;
  end;

  Trennen;
  RefreshPanel;

  EmpfangDatei := '';
  SendenDatei := '';

  if LizenzAnzeige then
  begin
    InfoForm := TInfoForm.Create(self);
    if InfoForm.ShowModal = mrOK then
      LizenzAnzeige := not InfoForm.CheckBox.Checked;
    InfoForm.Free;
  end;
end;

procedure TMainForm.FormShow(Sender: TObject);
var
  i: integer;
  IniDatei: TIniFile;
  SectionsListe: TStringList;
  WerteListe: TStringList;
  FormularClass: TClass;
  Form: TForm;
begin
  SectionsListe := TStringList.Create;
  WerteListe := TStringList.Create;

  IniDatei := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    IniDatei.ReadSections(SectionsListe);
    for i := SectionsListe.Count - 1 downto 0 do
    begin
      if AnsiStartsText('MDIFormular', SectionsListe.Strings[i]) then
      begin
        FormularClass := GetClass(
              IniDatei.ReadString(SectionsListe.Strings[i], 'Typ', ''));
        if FormularClass <> nil then
        begin
          Form := MDIClientOeffnen(TFormClass(FormularClass));
          Form.Left := IniDatei.ReadInteger(SectionsListe.Strings[i], 'XPos', 0);
          Form.Top := IniDatei.ReadInteger(SectionsListe.Strings[i], 'YPos', 0);
          Form.Width := IniDatei.ReadInteger(SectionsListe.Strings[i], 'Breite', 0);
          Form.Height := IniDatei.ReadInteger(SectionsListe.Strings[i], 'Hoehe', 0);
          if Form is TEmpfangPrototypForm then
          begin
            WerteListe.Clear;
            IniDatei.ReadSectionValues(SectionsListe.Strings[i], WerteListe);
            TEmpfangPrototypForm(Form).KonfigLaden(WerteListe);
          end;
          if Form is TProtokollForm then
            ProtokollForm := Form;
        end;
      end;
    end;
  finally
    WerteListe.Free;
    SectionsListe.Free;
    IniDatei.Free;
  end;

  GetDeviceList;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i, j: integer;
  IniDatei: TIniFile;
  IniSections: TStringList;
  WerteListe: TStringList;
  Form: TForm;
begin
  WerteListe := TStringList.Create;

  IniDatei := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    IniDatei.WriteBool('Allgemein', 'Lizenz', LizenzAnzeige);
    IniDatei.WriteString('Allgemein', 'DongleSerienNr', DongleSerNr);
    IniDatei.WriteInteger('CAN', 'BaudIdx', CANBaudIdx);
    IniDatei.WriteBool('CAN', 'ListenOnly', ListenOnlyAktiv);
    IniDatei.WriteBool('CAN', 'LoopBack', LoopBackAktiv);
    IniDatei.WriteInteger('Allgemein', 'RxRefresh', RxRefreshRate);
    IniDatei.WriteBool('Allgemein', 'RxASCIIAnzeige', ASCIISpalteAktiv);

    IniDatei.WriteInteger('SlotDaten', 'Maske0', Mask0Edit.Tag);
    IniDatei.WriteInteger('SlotDaten', 'Maske14', Mask14Edit.Tag);
    for i := 0 to SlotNum-1 do
    begin
      IniDatei.WriteInteger('SlotDaten', 'Slot'+IntToStr(i)+'ID', PSlotInfo(SlotList[i]).ID);
      IniDatei.WriteInteger('SlotDaten', 'Slot'+IntToStr(i)+'Flags', PSlotInfo(SlotList[i]).Flags);
    end;

    IniDatei.WriteInteger('AppliFenster', 'XPos', Left);
    IniDatei.WriteInteger('AppliFenster', 'YPos', Top);
    IniDatei.WriteInteger('AppliFenster', 'Breite', Width);
    IniDatei.WriteInteger('AppliFenster', 'Hoehe', Height);

    IniSections := TStringList.Create;
    IniDatei.ReadSections(IniSections);
    for i := 0 to IniSections.Count - 1 do
    begin
      if AnsiStartsText('MDIFormular', IniSections.Strings[i]) then
      begin
        IniDatei.EraseSection(IniSections.Strings[i]);
      end;
    end;
    IniSections.Free;

    for i := 0 to pred(MDIChildCount) do
    begin
      Form := self.MDIChildren[i];
      IniDatei.WriteString(format('MDIFormular%u',[i]), 'Typ', Form.ClassName);
      IniDatei.WriteInteger(format('MDIFormular%u',[i]), 'XPos', Form.Left);
      IniDatei.WriteInteger(format('MDIFormular%u',[i]), 'YPos', Form.Top);
      IniDatei.WriteInteger(format('MDIFormular%u',[i]), 'Breite', Form.Width);
      IniDatei.WriteInteger(format('MDIFormular%u',[i]), 'Hoehe', Form.Height);
      if Form is TEmpfangPrototypForm then
      begin
        WerteListe.Clear;
        TEmpfangPrototypForm(Form).KonfigSichern(WerteListe);
        for j := 0 to WerteListe.Count - 1 do
          IniDatei.WriteString(format('MDIFormular%u',[i]), WerteListe.Names[j], WerteListe.ValueFromIndex[j]);
      end;
    end;
  finally
    WerteListe.Free;
    IniDatei.Free;
  end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
  RxListe: TList;
begin
  while (SlotList.Count > 0) do
  begin
    dispose(SlotList.Items[0]);
    SlotList.Delete(0);
  end;
  SlotList.Free;

  ComThread.Terminate;
  ComThread.Free;
  CloseHandle(hDongleRxEvent);

  RxListe := CANEingangsListe.LockList;
  while (RxListe.Count > 0) do
  begin
    dispose(PCANrecord(RxListe.Items[0]));
    RxListe.Delete(0);
  end;
  CANEingangsListe.UnlockList;
  CANEingangsListe.Free;
end;

function TMainForm.MenuMDIClientHinzufuegen(Sender: TForm): TMenuItem;
begin
  result := TMenuItem.Create(self);
  result.Caption := Sender.Caption;
  result.OnClick := Sender.OnShow;
  Hauptmenu.Items.Find('Fenster').Add(result);
end;

procedure TMainForm.MenuMDIClientEntfernen(MenuItem: TMenuItem);
var
  MenuItemIndex: integer;
begin
  if assigned(Hauptmenu) then
  begin
    MenuItemIndex := Hauptmenu.Items.Find('Fenster').IndexOf(MenuItem);
    Hauptmenu.Items.Find('Fenster').Delete(MenuItemIndex);
  end;
end;

procedure TMainForm.actNextMDIExecute(Sender: TObject);
begin
  self.Next;
end;

procedure TMainForm.actPrevMDIExecute(Sender: TObject);
begin
  self.Previous;
end;

procedure TMainForm.RefreshPanel;
begin
  actStandardID.Enabled := not DongleActive;
  actErweiterteID.Enabled := not DongleActive;
end;

procedure TMainForm.actBeendenExecute(Sender: TObject);
begin
  close;
end;

procedure TMainForm.DongleListPopupPopup(Sender: TObject);
var
  MenuItem: TMenuItem;
  i, n: dword;
  DongleInfo: array of TFtDeviceInfo;
begin
  while DongleListPopup.Items.Count > 0 do
  begin
    MenuItem := DongleListPopup.Items[0];
    DongleListPopup.Items.Delete(0);
    MenuItem.Free;
  end;

  if FT_CreateDeviceInfoList(@n) <> FT_OK then
    exit;

  SetLength(DongleInfo, n);
  if n > 0 then
  begin
    if FT_GetDeviceInfoList(@DongleInfo[0], @n) <> FT_OK then
      exit;

    i := 0;
    while (i < n) do
    begin
      MenuItem := TMenuItem.Create(DongleListPopup);
      MenuItem.Tag := i;
      MenuItem.Caption := DongleInfo[i].Description + ', Ser.Nr.: ' + DongleInfo[i].SerialNumber;
      MenuItem.Enabled := not DongleActive;
      MenuItem.OnClick := OnPopupMenuItemClick;
      if DongleInfo[i].SerialNumber = DongleSerNr then
        MenuItem.Checked := true;
      DongleListPopup.Items.Add(MenuItem);
      inc(i);
    end;
  end
  else
  begin
    MenuItem := TMenuItem.Create(DongleListPopup);
    MenuItem.Caption := 'Kein Dongle verfgbar';
    MenuItem.Enabled := false;
    DongleListPopup.Items.Add(MenuItem);
  end;
end;


procedure TMainForm.OnPopupMenuItemClick(Sender: TObject);
var
  pcDongleSerNr: array[0..8] of char;
begin
  FT_ListDevices(pointer(TMenuItem(Sender).Tag), @pcDongleSerNr, FT_LIST_BY_INDEX or FT_OPEN_BY_SERIAL_NUMBER);
  DongleSerNr := pcDongleSerNr;
end;

function TMainForm.Verbinden(): integer;
var
  err: integer;
  DongleAnzahl: dword;
  pcDongleSerNr: array[0..8] of char;
begin
  result := 0;
  ProtokollAddLine('');

  err := FT_GetNumDevices(@DongleAnzahl);
  If err <> FT_OK then
  begin
    ProtokollAddLine('Fehler beim Ermitteln der Dongle Anzahl.');
    exit;
  end;
  case DongleAnzahl of
    0:  begin
          MessageDlg('Es sind keine CAN-Dongle angeschlossen.', mtError, [mbOK], 0);
          result := FT_DEVICE_NOT_FOUND;
          exit;
        end;
    1:  begin
          FT_ListDevices(pointer(0), @pcDongleSerNr, FT_LIST_BY_INDEX or FT_OPEN_BY_SERIAL_NUMBER);
          DongleSerNr := pcDongleSerNr;
        end;
  else
    if DongleSerNr = '' then
    begin
      VerindenToolBtn.CheckMenuDropdown;
      exit;
    end;
  end;

  err := FT_OpenEx(pchar(DongleSerNr), FT_OPEN_BY_SERIAL_NUMBER, @hDongle);
//  err := FT_Open(0, @hDongle);
  If err <> FT_OK then
  begin
    ProtokollAddLine('Fehler beim ffnen des Dongles.');
    exit;
  end;

  ComThread.hDongle := hDongle;
  err := FT_SetFlowControl(hDongle, 0, 0, 0); // FT_FLOW_NONE
  err := err or FT_SetBaudRate(hDongle, USBBaudRate);
  err := err or FT_SetDataCharacteristics(hDongle, 8, 0, 0); // 8N1
  err := err or FT_SetEventNotification(hDongle, 1, pointer(hDongleRxEvent)); // FT_EVENT_RXCHAR
//  FT_SetLatencyTimer(FT_HANDLE ftHandle, UCHAR ucTimer)
//  FT_SetUSBParameters(FT_HANDLE ftHandle, DWORD dwInTransferSize, DWORD dwOutTransferSize)
  If err <> FT_OK then
  begin
    ProtokollAddLine('Fehler beim Setzten der Schnittstellenparameter.');
    exit;
  end;

  if ComThread.Suspended then
    ComThread.Resume;

  ProtokollAddLine('Thread gestartet');

  DongleActive := true;
  actFirmwareUpdate.Enabled := false;
  actVerbinden.Caption := '&Trennen';
  VerindenToolBtn.ImageIndex := 1;
  VerbindungsStat := 1;
  StatusBar.Refresh;
  CANTimeOut.Enabled := true;

  CANReset;
end;

procedure TMainForm.Trennen;
var
  err: integer;
begin
  if not ComThread.Suspended then
    ComThread.Suspend;
//  sleep(10);
  ProtokollAddLine('Thread Suspended');
  if DongleActive then
  begin
    err :=  FT_Close(hDongle);
    If err <> FT_OK then
      ProtokollAddLine('Fehler beim Schlieen des Dongles');
  end;
  DongleActive := false;

  actFirmwareUpdate.Enabled := true;
  actVerbinden.Caption := '&Verbinden';
  VerindenToolBtn.ImageIndex := 0;
  VerbindungsStat := 0;
  StatusBar.Refresh;

  CANTimeOut.Enabled := false;
end;

procedure TMainForm.actEinstellungenExecute(Sender: TObject);
var
  Form: TEinstellungenForm;
  i: integer;
begin
  Form := TEinstellungenForm.Create(self);

  Form.CANBaudCombo.Items.Clear;
  for i := 0 to high(CANBaudParameter) do
    Form.CANBaudCombo.Items.Add(CANBaudParameter[i].Name);

  Form.CANBaudCombo.ItemIndex := CANBaudIdx;
  Form.ListenOnlyCheck.Checked := ListenOnlyAktiv;
  Form.LoopBackCheck.Checked := LoopBackAktiv;
  Form.RxRefreshRateSpin.Value := RxRefreshRate;
  Form.ASCIISpalteCheck.Checked := ASCIISpalteAktiv;

  if DongleActive then
  begin
    Form.CANBaudCombo.Enabled := false;
    Form.ListenOnlyCheck.Enabled := false;
    Form.LoopBackCheck.Enabled := false;
  end;

  if Form.ShowModal = mrOK then
  begin
    if not DongleActive then
    begin
      CANBaudIdx := Form.CANBaudCombo.ItemIndex;
      ListenOnlyAktiv := Form.ListenOnlyCheck.Checked;
      LoopBackAktiv := Form.LoopBackCheck.Checked;
    end;

    ASCIISpalteAktiv := Form.ASCIISpalteCheck.Checked;
    RxRefreshRate := Form.RxRefreshRateSpin.Value;

    for i := 0 to pred(MDIChildCount) do
    begin
      if MDIChildren[i] is TEmpfangForm then
      begin
        TEmpfangForm(MDIChildren[i]).SetColCount;
        if RxRefreshRate > 0 then
          TEmpfangForm(MDIChildren[i]).RefreshTimer.Enabled := true
        else
          TEmpfangForm(MDIChildren[i]).RefreshTimer.Enabled := false;
        TEmpfangForm(MDIChildren[i]).RefreshTimer.Interval := RxRefreshRate;
      end;
    end;
    StatusBar.Refresh;
  end;

  Form.Free;
end;

procedure TMainForm.actInfoExecute(Sender: TObject);
var
  Form: TForm;
begin
  Form := TInfoForm.Create(self);
  if Form.ShowModal = mrOK then
  begin
  end;
  Form.Free;
end;

procedure TMainForm.actVerbindenExecute(Sender: TObject);
begin
  if not DongleActive then
    Verbinden
  else
    Trennen;

  RefreshPanel;
end;

procedure TMainForm.SlotGridDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  Text: string;
  x,y: integer;
begin
  SlotGrid.Canvas.Brush.Color := SlotGrid.Color;
  SlotGrid.Canvas.Font.Color := clWindowText;

  if gdFocused in State then
  begin
    SlotGrid.Canvas.Brush.Color := clActiveCaption;
    SlotGrid.Canvas.Font.Color := clCaptionText;
  end
  else
    if gdFixed in State then
      SlotGrid.Canvas.Brush.Color := SlotGrid.FixedColor;
  SlotGrid.Canvas.FillRect(Rect);

  if ARow = 0 then
  begin
    case ACol of
      1:  SlotGrid.Canvas.TextOut(Rect.Left+1,Rect.Top+2,'ID');
      2:  SlotGrid.Canvas.TextOut(Rect.Left+1,Rect.Top+2,'<->');
      3:  SlotGrid.Canvas.TextOut(Rect.Left+1,Rect.Top+2,'Rm');
      4:  SlotGrid.Canvas.TextOut(Rect.Left+1,Rect.Top+2,'Status');
    end;
  end
  else
  begin
    case ACol of
      0:  begin
            SlotGrid.Canvas.TextOut(Rect.Left+1,Rect.Top+2,IntToStr(ARow-1));
          end;
      1:  begin
            Text := GetIDString(PSlotInfo(SlotList[ARow-1]).ID);
            SlotGrid.Canvas.TextOut(Rect.Left+1,Rect.Top+2,Text);
          end;
      2:  begin
            x := (SlotGrid.ColWidths[ACol] - CheckerImages.Width) div 2;
            y := (SlotGrid.DefaultRowHeight - CheckerImages.Height) div 2;
            CheckerImages.Draw(SlotGrid.Canvas,Rect.Left+x,Rect.Top+y,SlotStatImage[PSlotInfo(SlotList[ARow-1]).Flags and $03]);
          end;
      3:  begin
            x := (SlotGrid.ColWidths[ACol] - CheckerImages.Width) div 2;
            y := (SlotGrid.DefaultRowHeight - CheckerImages.Height) div 2;
            CheckerImages.Draw(SlotGrid.Canvas,Rect.Left+x,Rect.Top+y,(PSlotInfo(SlotList[ARow-1]).Flags shr 2) and $01);
          end;
    end;
  end;

  if (ACol = SlotGrid.Col) and (ARow = SlotGrid.Row) then
    SlotGrid.Canvas.DrawFocusRect(Rect);
end;

procedure TMainForm.SendCommand(Data: PByte; Size: Cardinal);
var
  i,j,n: integer;
  err: integer;
  TxBuffer: array[0..32] of byte;
begin
  if VerbindungsStat < 1 then
    exit;

  j := 0;
  TxBuffer[j] := STARTTAG;
  inc(j);
  for i := 0 to Size-1 do
  begin
    TxBuffer[j] := Data^;
    inc(j);
    if (Data^ = $aa) or (Data^ = $a5) then
    begin
      TxBuffer[j] := Data^;
      inc(j);
    end;
    inc(Data);
  end;
  TxBuffer[j] := ENDTAG;
  inc(j);

  err := FT_Write(hDongle, @TxBuffer, j, @n);
  if (err <> FT_OK) or (j <> n) then
    ProtokollAddLine('Fehler beim Senden von Daten.');

//  err := FT_GetStatus(hDongle, @j, @n, @i);
//  ProtokollAddLine(format('Write Status: %d, %d, %d',[j,n,i]));
end;

procedure TMainForm.CANReset;
var
  Buffer: array[0..5] of byte;
begin
  ProtokollAddLine('Dongle-Reset senden');

  RxNachrichtenCount := 0;
  TxNachrichtenCount := 0;
  RxFehler := 0;
  TxFehler := 0;
  RefreshStatusBar;

  Buffer[0] := 6;                       // Nachrichtenlnge
  Buffer[1] := RESETCMD;
  Buffer[2] := $08;                     // Flag, Bit3: Basic CAN
  if ListenOnlyAktiv then
    Buffer[2] := Buffer[2] or $20;      // Flags, Bit5: Listen only
  if LoopBackAktiv then
    Buffer[2] := Buffer[2] or $02;      // Flags, Bit1: Loopback
  Buffer[3] := CANBaudParameter[CANBaudIdx].cclkr;  // CAN-Baud
  Buffer[4] := CANBaudParameter[CANBaudIdx].c0conrl;// CAN-Baud
  Buffer[5] := CANBaudParameter[CANBaudIdx].c0conrh;// CAN-Baud

  SendCommand(@Buffer, Buffer[0]);
end;

procedure TMainForm.SendSlotIDs(SlotNr: integer);
var
  PLong: pdword;
  Buffer: array[0..5] of byte;
begin
  if actStandardID.Checked then
    Buffer[0] := 4
  else
    Buffer[0] := 6;

  Buffer[1] := CANMSGDISABLE;
  if (PSlotInfo(SlotList[SlotNr]).Flags and $01) = $01 then
    Buffer[1] := CANMSGEMPGANG;
// drfte hier nie auftreten
  if (PSlotInfo(SlotList[SlotNr]).Flags and $03) = $02 then
    Buffer[1] := CANMSGSEND;
// -----
  if (PSlotInfo(SlotList[SlotNr]).Flags and $04) > 0 then   // Remote
    Buffer[1] := Buffer[1] or $20;
  if actErweiterteID.Checked then
    Buffer[1] := Buffer[1] or $10;
  Buffer[1] := Buffer[1] or (SlotNr);

  Plong := @Buffer[2];
  Plong^ := PSlotInfo(SlotList[SlotNr]).ID;

  SendCommand(@Buffer, Buffer[0]);

  if (SlotNr = 14) then
  begin
    Buffer[1] := Buffer[1] + 1;
    SendCommand(@Buffer, Buffer[0]);
  end;

  ProtokollAddLine(format('Slot %u initialisiert',[SlotNr]));
end;

procedure TMainForm.SlotGridGetEditText(Sender: TObject; ACol, ARow: Integer; var Value: String);
begin
  if ACol = 1 then
    Value := GetIDString(PSlotInfo(SlotList[ARow-1]).ID);
end;

function TMainForm.MDIClientOeffnen(ClientForm: TFormClass): TForm;
var
  i: integer;
begin
  if not(ClientForm.ClassParent = TEmpfangPrototypForm) then
  begin
    for i:=0 to pred(MDIChildCount) do
    begin
      if (MDIChildren[i] is ClientForm) then
      begin
        result:=MDIChildren[i];
        result.BringToFront;
        result.WindowState:=wsNormal;
        exit;
      end;
    end;
  end;
  result:=ClientForm.Create(self);
end;

procedure TMainForm.actEmpfangsFensterExecute(Sender: TObject);
var
  Form: TForm;
begin
  Form := MDIClientOeffnen(TEmpfangForm);
  if RxRefreshRate > 0 then
    TEmpfangForm(Form).RefreshTimer.Enabled := true
  else
    TEmpfangForm(Form).RefreshTimer.Enabled := false;
  TEmpfangForm(Form).RefreshTimer.Interval := RxRefreshRate;
end;

procedure TMainForm.actSendeFensterExecute(Sender: TObject);
begin
  MDIClientOeffnen(TSendenForm);
end;

procedure TMainForm.actProtokollExecute(Sender: TObject);
begin
  ProtokollForm := MDIClientOeffnen(TProtokollForm);
end;

procedure TMainForm.actAnalogInstrumentFensterExecute(Sender: TObject);
begin
  MDIClientOeffnen(TAnalogInstrumentForm);
end;

procedure TMainForm.actOszillogrammFensterExecute(Sender: TObject);
begin
  MDIClientOeffnen(TOszillogrammForm);
end;

procedure TMainForm.actWertAnzeigeFensterExecute(Sender: TObject);
begin
  MDIClientOeffnen(TWertAnzeigeForm);
end;

procedure TMainForm.actBitIndikatorFensterExecute(Sender: TObject);
begin
  MDIClientOeffnen(TBitIndikatorForm);
end;

procedure TMainForm.actFirmwareUpdateExecute(Sender: TObject);
var
  i: integer;
  TempForm: TFirmwareForm;
begin
  if DongleActive then
    exit;

  TempForm := TFirmwareForm.Create(self);
  if DongleSerNr <> '' then
  begin
    TempForm.SerienNrComboBox.Items.Add(DongleSerNr);
    TempForm.SerienNrComboBox.ItemIndex := 0;
  end;
  TempForm.ShowModal;

  if (DongleSerNr <> '') then
  begin
    i := pos('; ', TempForm.SerienNrComboBox.Text) - 1;
    if i < 0 then
      i := length(TempForm.SerienNrComboBox.Text);
    DongleSerNr := copy(TempForm.SerienNrComboBox.Text, 0, i);
  end;

  TempForm.Free;
end;

procedure TMainForm.SlotGridSelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
begin
  if (ACol in [2,3]) then
    SlotGrid.Options := SlotGrid.Options - [GoEditing]
  else
    SlotGrid.Options := SlotGrid.Options + [GoEditing];

//  RefreshSlotID(self);
end;

procedure TMainForm.SlotGridKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = ' ' then
  begin
    case SlotGrid.Col of
      2:  begin
            if (PSlotInfo(SlotList[SlotGrid.Row-1]).Flags and $03) < 1 then
              PSlotInfo(SlotList[SlotGrid.Row-1]).Flags := PSlotInfo(SlotList[SlotGrid.Row-1]).Flags + 1
            else
              PSlotInfo(SlotList[SlotGrid.Row-1]).Flags := PSlotInfo(SlotList[SlotGrid.Row-1]).Flags and $fc;
            SendSlotIDs(SlotGrid.Row-1);
          end;
      3:  begin
            if SlotGrid.Row < 15 then // Slot 14/15 drfen nicht auf Remote gesetzt werden
            begin
              PSlotInfo(SlotList[SlotGrid.Row-1]).Flags := PSlotInfo(SlotList[SlotGrid.Row-1]).Flags xor $04;
              SendSlotIDs(SlotGrid.Row-1);
            end;
          end;
    end;
    SlotGridDrawCell(self, SlotGrid.Col, SlotGrid.Row, SlotGrid.CellRect(SlotGrid.Col, SlotGrid.Row), []);
  end;

  if (ord(Key) = VK_RETURN) and (SlotGrid.Col = 1) then
    SendSlotIDs(SlotGrid.Row-1);
end;

procedure TMainForm.SlotGridMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  ACol, ARow: integer;
  Key: Char;
begin
  SlotGrid.MouseToCell(X, Y, ACol, ARow);
  if (ACol = SlotGrid.Col) and (ARow = SlotGrid.Row) then
    if (ACol in [2,3]) then
    begin
      Key := ' ';
      SlotGridKeyPress(Sender, Key);
    end;
end;

procedure TMainForm.SlotGridSetEditText(Sender: TObject; ACol, ARow: Integer; const Value: String);
begin
  CheckZahlenEingabe(Value, PCANrecord(SlotList.Items[ARow-1]).ID, MaxID);
end;

procedure TMainForm.CANTimeOutTimer(Sender: TObject);
begin
  beep;
  ProtokollAddLine('Zeitberschreitung, CAN-Interface nicht gefunden.');
  Trennen;
end;

procedure TMainForm.actStandardIDExecute(Sender: TObject);
begin
  actStandardID.Checked := true;
  actErweiterteID.Checked := false;
  IDLaenge := 3;
  MaxID := $7ff;
  SlotGrid.Refresh;
  HexEditViewValue(Mask0Edit);
  HexEditViewValue(Mask14Edit);
  RefreshMDIClients;
end;

procedure TMainForm.actErweiterteIDExecute(Sender: TObject);
begin
  actStandardID.Checked := false;
  actErweiterteID.Checked := true;
  IDLaenge := 8;
  MaxID := $1fffffff;
  SlotGrid.Refresh;
  HexEditViewValue(Mask0Edit);
  HexEditViewValue(Mask14Edit);
  RefreshMDIClients;
end;

procedure TMainForm.actDezIDExecute(Sender: TObject);
begin
  actDezID.Checked := true;
  actHexID.Checked := false;
  actBinID.Checked := false;
  SlotGrid.Refresh;
  RefreshMDIClients;
end;

procedure TMainForm.actHexIDExecute(Sender: TObject);
begin
  actDezID.Checked := false;
  actHexID.Checked := true;
  actBinID.Checked := false;
  SlotGrid.Refresh;
  RefreshMDIClients;
end;

procedure TMainForm.actBinIDExecute(Sender: TObject);
begin
  actDezID.Checked := false;
  actHexID.Checked := false;
  actBinID.Checked := true;
  SlotGrid.Refresh;
  RefreshMDIClients;
end;

procedure TMainForm.actDezDatenExecute(Sender: TObject);
begin
  actDezDaten.Checked := true;
  actHexDaten.Checked := false;
  actBinDaten.Checked := false;
  RefreshMDIClients;
end;

procedure TMainForm.actHexDatenExecute(Sender: TObject);
begin
  actDezDaten.Checked := false;
  actHexDaten.Checked := true;
  actBinDaten.Checked := false;
  RefreshMDIClients;
end;

procedure TMainForm.actBinDatenExecute(Sender: TObject);
begin
  actDezDaten.Checked := false;
  actHexDaten.Checked := false;
  actBinDaten.Checked := true;
  RefreshMDIClients;
end;

procedure TMainForm.RefreshMDIClients;
var
  i: integer;
begin
  for i:=0 to pred(MDIChildCount) do
  begin
    if (MDIChildren[i] is TSendenForm) then
    begin
      TSendenForm(MDIChildren[i]).NachrichtenGrid.Refresh;
      TSendenForm(MDIChildren[i]).BerechneColWidth;
    end;
    if (MDIChildren[i] is TEmpfangForm) then
    begin
      TEmpfangForm(MDIChildren[i]).NachrichtenGrid.Refresh;
      TEmpfangForm(MDIChildren[i]).BerechneColWidth;
    end;
  end;
end;

procedure TMainForm.StatusBarDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
begin
  if Panel.ID = 0 then
  begin
    USBImages.Draw(StatusBar.Canvas, Rect.Left+1, Rect.Top, VerbindungsStat);
    StatusBar.Canvas.TextOut(Rect.Left + USBImages.Width + 5, Rect.Top + 1,
          CANBaudParameter[CANBaudIdx].Name);
  end;
end;

procedure TMainForm.IniAllSlots;
var
  i: integer;
begin
  ProtokollAddLine('Initialisierung aller Slots und Masken');

  // IDs der Slots bermitteln
  for i := 0 to SlotNum - 1 do
    SendSlotIDs(i);

  HexEditConfirm(Mask0Edit);
  HexEditConfirm(Mask14Edit);
end;

function  TMainForm.CheckZahlenEingabe(NumString: string; var Value: byte; MaxValue: dword): integer;
var
  temp: dword;
begin
  temp := Value;
  result := CheckZahlenEingabe(NumString, temp, MaxValue);
  Value := temp;
end;

function  TMainForm.CheckZahlenEingabe(NumString: string; var Value: word; MaxValue: dword): integer;
var
  temp: dword;
begin
  temp := Value;
  result := CheckZahlenEingabe(NumString, temp, MaxValue);
  Value := temp;
end;

function TMainForm.CheckZahlenTEditEingabe(Sender: TEdit; MaxValue: dword): integer;
var
  temp: dword;
begin
  temp := Sender.Tag;
  result := CheckZahlenEingabe(Sender.Text, temp, MaxValue);
  Sender.Tag := temp;
end;

function TMainForm.CheckZahlenEingabe(NumString: string; var Value: dword; MaxValue: dword): integer;
var
  i: integer;
begin
  result := -1;
  NumString := LowerCase(trim(NumString));

  if length(NumString) < 1 then
    exit;

  case NumString[1] of
    '$':      // Hexadezimale Zahlenangabe
        begin
          Value := 0;
          i := 1;
          while (i < length(NumString)) and (Value <= MaxValue) do
          begin
            if ((NumString[i+1] >= '0') and (NumString[i+1] <= '9')) then
              Value := (Value shl 4) + (ord(NumString[i+1]) and $0f)
            else
              if ((NumString[i+1] >= 'a') and (NumString[i+1] <= 'f')) then
                Value := (Value shl 4) + (ord(NumString[i+1]) and $0f + 9)
              else
                exit;
            inc(i);
          end;
        end;
    '0'..'9': // Dezimale Zahlenangabe
        begin
          Value := 0;
          i := 0;
          while (i < length(NumString)) and (Value <= MaxValue) do
          begin
            if ((NumString[i+1] >= '0') and (NumString[i+1] <= '9')) then
              Value := (Value * 10) + (ord(NumString[i+1]) and $0f)
            else
              exit;
            inc(i);
          end;
        end;
    'b':  // Binre Zahlenangabe
        begin
          Value := 0;
          i := 1;
          while (i < length(NumString)) and (Value <= MaxValue) do
          begin
            case NumString[i+1] of
              '0': Value := (Value shl 1);
              '1': Value := (Value shl 1) + 1;
            else
              exit;
            end;
            inc(i);
          end;
        end;
  end;
end;

procedure TMainForm.HexEditViewValue(Sender: TObject);
begin
  TEdit(Sender).Text := GetIDString(TEdit(Sender).Tag);
end;

procedure TMainForm.HexEditKeyPress(Sender: TObject; var Key: Char);
var
  NumString: string;
begin
  if (ord(Key) = VK_RETURN) then
  begin
    HexEditConfirm(Sender);
    Key := #0;
    exit;
  end;

  if (ord(Key) in [VK_BACK]) then
    exit;

  NumString := LowerCase(trim(TEdit(Sender).Text));

  if (TEdit(Sender).SelStart < 1) then
  begin
    if (not (Key in ['$','b','B'])) and ((Key < '0') or (Key > '9')) then
    begin
      Key := #0;
      beep;
    end;
    exit;
  end;

  case NumString[1] of
    '$':
      begin
        if (not (Key in ['a'..'f','A'..'F'])) and ((Key < '0') or (Key > '9')) then
          Key := #0;
      end;
    'b','B':
      begin
        if ((Key < '0') or (Key > '1')) then
          Key := #0;
      end;
    else
      begin
        if ((Key < '0') or (Key > '9')) then
          Key := #0;
      end;
  end;

  if ord(Key) = 0 then
    beep;
end;

procedure TMainForm.HexEditChange(Sender: TObject);
begin
  CheckZahlenTEditEingabe(TEdit(Sender), MaxID);
end;

procedure TMainForm.HexEditConfirm(Sender: TObject);
var
  Buffer: array[0..5] of byte;
  PLong: pdword;
begin
  HexEditViewValue(Sender);

  if (Sender = Mask0Edit) then
    Buffer[1] := MASK0CMD;

  if (Sender = Mask14Edit) then
    Buffer[1] := MASK14CMD;

  if actStandardID.Checked then
    Buffer[0] := 4
  else
  begin
    Buffer[0] := 6;
    Buffer[1] := Buffer[1] or $10;
  end;

  // Maske fr senden
  Plong := @Buffer[2];
  Plong^ := TEdit(Sender).Tag;
  SendCommand(@Buffer, Buffer[0]);

  if (Sender = Mask14Edit) then
  begin
    Buffer[1] := MASK15CMD;
    if actErweiterteID.Checked then
      Buffer[1] := Buffer[1] or $10;
    SendCommand(@Buffer, Buffer[0]);
  end;
end;

function TMainForm.GetIDString(ID: dword): string;
begin
  if actDezID.Checked then
    result := format('%u',[ID]);
  if actHexID.Checked then
    result := '$' + RightStr(format('00000000%x',[ID]),IDLaenge);
  if actBinID.Checked then
    result := 'Bin';
end;

function TMainForm.GetDataString(Data: dword): string;
var
  i, j: dword;
begin
  if actDezDaten.Checked then
    result := format('%u',[Data]);
  if actHexDaten.Checked then
    result := '$' + RightStr(format('00%x',[Data]),2);
  if actBinDaten.Checked then
  begin
    result := '00000000';
    j := Data;
    for i := 1 to 8 do
    begin
      if (j and $80) > 0 then
        result[i] := '1';
      j := j shl 1;
    end;
  end;
end;

procedure TMainForm.SlotGridExit(Sender: TObject);
begin
  if SlotGrid.EditorMode then
    SendSlotIDs(SlotGrid.Row - 1);
end;

procedure TMainForm.RefreshStatusBar;
begin
  StatusBar.Panels[1].Text := format('RxMsg: %d',[RxNachrichtenCount]);
  StatusBar.Panels[2].Text := format('TxMsg: %d',[TxNachrichtenCount]);
  StatusBar.Panels[3].Text := format('RxFehler: %d',[RxFehler]);
  StatusBar.Panels[4].Text := format('TxFehler: %d',[TxFehler]);
  StatusBar.Panels[5].Text := format('Puffer max.: %d',[PufferMax]);
end;

procedure TMainForm.actSlotResetExecute(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to SlotNum-1 do
  begin
    PSlotInfo(SlotList[i]).ID := 0;
    PSlotInfo(SlotList[i]).Flags := 0;
  end;
  SlotGrid.Refresh;
end;

procedure TMainForm.actZaehlerResetExecute(Sender: TObject);
begin
  RxNachrichtenCount := 0;
  TxNachrichtenCount := 0;
  RxFehler := 0;
  TxFehler := 0;
  PufferAktuell := 0;
  PufferMax := 0;
  RefreshStatusBar;
end;

procedure TMainForm.IncTxZaehler;
begin
  inc(TxNachrichtenCount);
  StatusBar.Panels[2].Text := format('TxMsg: %d',[TxNachrichtenCount]);
end;

procedure TMainForm.actInstrumentOeffnenExecute(Sender: TObject);
var
  i: integer;
  Datei: TIniFile;
  SectionsListe: TStringList;
  WerteListe: TStringList;
  tempListe: TStrings;
  FormularClass: TClass;
  Form: TForm;
begin
  SectionsListe := TStringList.Create;
  WerteListe := TStringList.Create;
  tempListe := TStringList.Create;

  OpenDialog.Title := 'Instrument laden';
  OpenDialog.DefaultExt := 'cin';
  OpenDialog.Filter := 'Instrument (*.cin)|*.cin|Alle Dateien (*.*)|*.*';

  if OpenDialog.Execute then
  begin
    Datei := TIniFile.Create(OpenDialog.FileName);
    try
      FormularClass := GetClass(Datei.ReadString('Allgemein', 'Typ', ''));
      if (FormularClass <> nil) then
      begin
        Form := MDIClientOeffnen(TFormClass(FormularClass));
        if Form is TEmpfangPrototypForm then
        begin
          Datei.ReadSections(SectionsListe);
          for i := 0 to SectionsListe.Count - 1 do
          begin
            Datei.ReadSectionValues(SectionsListe.Strings[i], tempListe);
            WerteListe.AddStrings(tempListe);
          end;
          MessageDlg('Werte: '+IntToStr(WerteListe.Count),mtInformation,[mbOK],0);
          TEmpfangPrototypForm(Form).KonfigLaden(WerteListe);
        end;
      end;
    finally
      WerteListe.Free;
      tempListe.Free;
      SectionsListe.Free;
      Datei.Free;
    end;
  end;
end;

procedure TMainForm.GetDeviceList;
var
  err: integer;
  i: integer;
  n: dword;
  Info: array of TFtDeviceInfo;
  LibVer: dword;
begin
  err := FT_GetLibraryVersion(@LibVer);
  err := err or FT_CreateDeviceInfoList(@n);
  if err <> FT_OK then
  begin
    ProtokollAddLine('Fehler beim Erstellen der Dongle-Infosliste');
    exit;
  end;
  ProtokollAddLine(format('Anzahl Dongles: %d | LibVersion: %0.2x.%0.2x.%0.2x',
        [n, (LibVer shr 16) and $ff, (LibVer shr 8) and $ff, LibVer and $ff]));

  SetLength(Info, n);
  err := FT_GetDeviceInfoList(@Info[0], @n);
  if err <> FT_OK then
  begin
    ProtokollAddLine('Fehler beim Abfragen der Dongle-Infos');
    exit;
  end;

  for i := 0 to n-1 do
  begin
    ProtokollAddLine(format('Typ: %d | VID: %0.4x | PID: %0.4x | LocID: %d | SerNr: %s | Beschr.: %s',
        [Info[i].Typ, Info[i].VID, Info[i].PID, Info[i].LocId, Info[i].SerialNumber, Info[i].Description]));
  end;
end;

procedure TMainForm.ProtokollAddLine(s: string);
begin
  if assigned(ProtokollForm) then
  begin
    if TProtokollForm(ProtokollForm).Memo.Lines.Count >= 256 then
      TProtokollForm(ProtokollForm).Memo.Lines.Delete(0);
    TProtokollForm(ProtokollForm).Memo.Lines.Append(s);
  end;
end;

procedure TMainForm.OnThreadTextMsg(s: string);
begin
  ProtokollAddLine(s);
end;

procedure TMainForm.OnDongleResetAckn(var Msg: TMessage);
begin
  ProtokollAddLine('Dongle-Reset besttigt');
  CANTimeOut.Enabled := false;
  VerbindungsStat := 2;
  StatusBar.Refresh;
  IniAllSlots;
end;

procedure TMainForm.OnDongleRx(var Msg: TMessage);
var
  i: integer;
  Form: TForm;
  RxListe: TList;
  pMsg: PCANrecord;
  FreeMsg: boolean;
begin
  PufferAktuell := CANEingangsListe.LockList.Count;
  CANEingangsListe.UnlockList;
  if PufferAktuell > PufferMax then
  begin
    PufferMax := PufferAktuell;
    RefreshStatusBar;
  end;

  while PufferAktuell > 0 do
  begin
    inc(RxNachrichtenCount);
    StatusBar.Panels[1].Text := format('RxMsg: %d',[RxNachrichtenCount]);
    FreeMsg := true;
    RxListe := CANEingangsListe.LockList;
    pMsg := RxListe.Items[0];
    RxListe.Delete(0);
    CANEingangsListe.UnlockList;
    if (pMsg.Cmd and $c0) <> 0 then
    begin
      if (pMsg.Cmd and $10) = 0 then
        pMsg.ID := pMsg.ID shr 16;

      for i := 0 to pred(MDIChildCount) do
      begin
        Form := MDIChildren[i];
        if (Form is TEmpfangPrototypForm) then
          TEmpfangPrototypForm(Form).NeueNachricht(pMsg, FreeMsg);
      end;
    end;
    if FreeMsg then
      dispose(pMsg);
    dec(PufferAktuell);
//  Application.ProcessMessages;
  end;
end;

procedure TMainForm.OnDongleCANError(var Msg: TMessage);
begin
  ;
end;

{ TComThread }

constructor TComThread.Create(AOwner: TMainForm);
begin
  Owner := AOwner;
  hOwner := Owner.Handle;
  hRxEvent := owner.hDongleRxEvent;
  inherited Create(True);
//  Priority := tpHigher;
  FreeOnTerminate := false;
end;

procedure TComThread.Execute;
var
  i: integer;
  pRxDat: pbyte;
  MsgTagFound: byte;
  MsgStarted: boolean;
  MsgByteNum: integer;
  MsgLength: integer;
  MsgDataBegin: integer;
  pMsg: PCANrecord;
  WaitResult: dword;
begin
  inherited;
  SetName;
                                                
  pMsg := nil;
  MsgTagFound := 0;
  MsgStarted := false;
  MsgByteNum := 0;
  MsgLength := 0;
  MsgDataBegin := 0;

  try
    while not Terminated do
    begin
      WaitResult := WaitForSingleObject(hRxEvent, 1000);
      case WaitResult of
//        WAIT_OBJECT_0:  ;
        WAIT_TIMEOUT:
            begin
//              TextNachricht := 'Auf Daten warten.';
//              Synchronize(SendeTextNachricht);
              continue;
            end;
        WAIT_FAILED:
            begin
              TextNachricht := 'Fehler beim Warten auf Daten.';
              Synchronize(SendeTextNachricht);
              continue;
            end;
      end;

      // Es wurden Daten empfangen.
      ResetEvent(hRxEvent);

      // Prfen, ob Daten im Empfangspuffer
      Synchronize(GetQueueStatus);
      If err <> FT_OK then
      begin
        TextNachricht := 'Fehler beim Abfragen des Warteschlangenstatus.';
        Synchronize(SendeTextNachricht);
        continue;
      end;

      // Buffer Lesen
      if RxByteInQueue > 0 then
      begin
        Synchronize(ReadQueue);
        If err <> FT_OK then
        begin
          TextNachricht := 'Fehler beim Daten lesen.';
          Synchronize(SendeTextNachricht);
        end;
//        TextNachricht := format('Daten empfangen: %d, %d',[RxByteInQueue, RxBytes]);
//        Synchronize(SendeTextNachricht);

        pRxDat := @RxBuffer[0];
        while (RxBytes > 0) do
        begin
          if (pRxDat^ = STARTTAG) or (pRxDat^ = ENDTAG) then
          begin
            // Prfen ob START-/ENDTAG gefunden wurde oder ein doppelzeichen
            if (MsgTagFound <> pRxDat^) then
            begin
              MsgTagFound := pRxDat^;
              if (pRxDat^ = ENDTAG) then
              begin
                // Prfen, ob Nachrichtenlnge past
                if (MsgByteNum = MsgLength) and MsgStarted then
                begin
                  MsgStarted := false;
                  MsgTagFound := 0;
                  // Kommando bearbeiten
                  case (pMsg.Cmd) of
                    RESETCMD:
                      begin
                        PostMessage(hOwner, WM_DONGLERESETACKN, 0, 0);
                      end;
                    CANERROR:
                      begin
                        PostMessage(hOwner, WM_DONGLECANERROR, 0, 0);
                      end;
                  else
                    begin
                      for i := pMsg.DLC to 7 do
                        pMsg.Data[i] := 0;
                      owner.CANEingangsListe.Add(pMsg);
                      pMsg := nil;
                      PostMessage(hOwner, WM_DONGLERXDATA, 0, 0);
                    end;
                  end;
                end;
              end;
            end
            else  // if (MsgTagFound <> PBuffer^) then
            begin // Doppelzeichen gefunden
              MsgTagFound := 0;
            end;
          end
          else
          begin
            if (MsgTagFound = STARTTAG) then
            begin
              MsgStarted := true;
              MsgByteNum := 0;
              if not assigned(pMsg) then
                new(pMsg);
              pMsg.ID := 0;
              pMsg.DLC := 0;
              pMsg.Timestamp := 0;
            end;
            if (MsgTagFound = ENDTAG) then
              MsgStarted := false;
            MsgTagFound := 0;
          end;

          if (MsgByteNum > MsgLength) then
            MsgStarted := false;

          if (MsgTagFound = 0) and (MsgStarted) then
          begin
            if (MsgByteNum = 0) then
              MsgLength := pRxDat^;

            // Kommando
            if (MsgByteNum = 1) then
            begin
              pMsg.Cmd := pRxDat^;
              if (pMsg.Cmd and $e0) = $20 then
                MsgDataBegin := 2
              else
                if (pMsg.Cmd and $10) = $00 then
                  MsgDataBegin := 7
                else
                  MsgDataBegin := 9;
            end;

            // Zeitstempel
            if (MsgByteNum >= 2) and (MsgByteNum < MsgDataBegin-2) then
              pMsg.Timestamp := (pMsg.Timestamp shr 8) or (pRxDat^ shl 16);

            // ID
            if (MsgByteNum >= 5) and (MsgByteNum < MsgDataBegin) then
              pMsg.ID := (pMsg.ID shr 8) or (pRxDat^ shl 24);

            // Daten
            if (MsgByteNum >= MsgDataBegin) then
            begin
              pMsg.Data[pMsg.DLC] := pRxDat^;
              inc(pMsg.DLC);
            end;
            inc(MsgByteNum);
          end;
          inc(pRxDat);
          dec(RxBytes);
        end;
      end;
    end;
  except
    TextNachricht := 'Fehler bei der Threadausfhrung aufgetreten.';
    Synchronize(SendeTextNachricht);
  end;
end;

procedure TComThread.SendeTextNachricht;
begin
  Owner.OnThreadTextMsg(TextNachricht);
end;

procedure TComThread.GetQueueStatus;
begin
  err := FT_GetQueueStatus(hDongle,@RxByteInQueue);
end;

procedure TComThread.ReadQueue;
begin
  err := FT_Read(hDongle , @RxBuffer, RxByteInQueue, @RxBytes);
end;

procedure TComThread.SetName;
var
  ThreadNameInfo: TThreadNameInfo;
begin
  ThreadNameInfo.FType := $1000;
  ThreadNameInfo.FName := 'DongelComThread';
  ThreadNameInfo.FThreadID := $FFFFFFFF;
  ThreadNameInfo.FFlags := 0;
  try
    RaiseException($406D1388, 0, sizeof(ThreadNameInfo) div sizeof(dword), @ThreadNameInfo);
  except
  end;
end;

initialization
  RegisterClasses([TProtokollForm, TEmpfangForm, TSendenForm,
        TAnalogInstrumentForm, TOszillogrammForm, TBitIndikatorForm,
        TWertAnzeigeForm]);

end.
