unit Interpreter;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Hauptfenster, IntegerTerm, ExtCtrls,
  EmpfangPrototyp;

type
  TInterpreterForm = class(TEmpfangPrototypForm)
    KonfigurierenBtn: TBitBtn;
    BitBtn1: TBitBtn;
    Edit1: TEdit;
    Memo1: TMemo;
    AktivChecker: TCheckBox;
    Edit2: TEdit;
    Label1: TLabel;
    Edit3: TEdit;
    Label2: TLabel;
    Panel1: TPanel;
    BitBtn2: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit2Enter(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private-Deklarationen }
    BerechnungsTerm: TIntTerm;
    Varis: VarArray;
  public
    { Public-Deklarationen }
    procedure NeueNachricht(CANrec: PCANrecord); override;
  end;

var
  InterpreterForm: TInterpreterForm;

implementation

{$R *.dfm}

{ TInterpreterForm }

procedure TInterpreterForm.FormCreate(Sender: TObject);
var
  i: integer;
begin
  Edit2.Text := TMainForm(Owner).GetIDString(Edit1.Tag);

  BerechnungsTerm := TIntTerm.Create;

  SetLength(Varis, 8);
  for i := 0 to high(Varis) do
  begin
    Varis[i].Name := format('d%u',[i]);
    Varis[i].Wert := 0;
  end;
end;

procedure TInterpreterForm.NeueNachricht(CANrec: PCANrecord);
var
  i, fs, fl: integer;
begin
  if (CANrec.ID = Edit2.Tag) and (AktivChecker.Checked) then
  begin
    for i := 0 to high(Varis) do
      Varis[i].Wert := CANrec.Data[i];

    try
      i := BerechnungsTerm.TermLoesen(Edit1.Text, @Varis);
      memo1.Lines.Add(format('Ergebnis : %d %s', [i, Edit3.Text]));
      panel1.Caption := format('%d %s', [i, Edit3.Text]);
    except
      beep;
      memo1.Lines.Add(BerechnungsTerm.GetFehlerText);
      BerechnungsTerm.GetFehler(@fs, @fl);
      edit1.SetFocus;
      edit1.SelStart := fs-1;
      edit1.SelLength := fl;
    end;
  end;
end;

procedure TInterpreterForm.BitBtn1Click(Sender: TObject);
var
  i, fs, fl: integer;
begin
  try
    i := BerechnungsTerm.TermLoesen(Edit1.Text, @Varis);
    memo1.Lines.Add(format('Ergebnis : %d',[i]))
  except
    memo1.Lines.Add(BerechnungsTerm.GetFehlerText);
    BerechnungsTerm.GetFehler(@fs, @fl);
    edit1.SetFocus;
    edit1.SelStart := fs-1;
    edit1.SelLength := fl;
  end;
end;

procedure TInterpreterForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//  MainForm.MenuMDIClientEntfernen(self);
//  TMainForm(owner).EmpfangsForm := nil;
  Action := caFree;
end;

procedure TInterpreterForm.Edit2Change(Sender: TObject);
begin
  TMainForm(Owner).CheckZahlenEingabe(TEdit(Sender).Text, @TEdit(Sender).Tag, TMainForm(Owner).MaxID);
end;

procedure TInterpreterForm.Edit2Enter(Sender: TObject);
begin
  TEdit(Sender).Text := TMainForm(Owner).GetIDString(TEdit(Sender).Tag);
end;

procedure TInterpreterForm.Edit2Exit(Sender: TObject);
begin
  TMainForm(Owner).HexEditViewValue(Sender);
end;

procedure TInterpreterForm.BitBtn2Click(Sender: TObject);
var
  test: TBitmap;
  x,y,xm,ym,r1,r2,w: integer;
begin
  self.Canvas.Pen.Color := clred;
  self.Canvas.Pen.Style := psSolid;
  self.Canvas.MoveTo(1,1);
  self.Canvas.LineTo(100, 100);
  self.Canvas.TextOut(200, 3, format('Martin %f',[sin(pi/2)]));
  test := TBitmap.Create;
  test.Width := 200;
  test.Height := 200;
  test.Canvas.Font.Color := clred;
  test.Canvas.TextOut(1,1,'Test');
  test.Canvas.Pen.Color := clblue;
  test.Canvas.Pen.Style := psSolid;
  test.Canvas.MoveTo(1,1);
  test.Canvas.LineTo(99, 99);
//  BitBlt(test.Canvas.Handle,0,0,50,50,self.Canvas.Handle,0,0,SRCCOPY);
  test.Canvas.Brush.Color := clBtnFace;
  test.Canvas.FillRect(Rect(0,0,100,100));

  xm:=100;
  ym:=100;
  r1:=round(ym / 100 * 85);
  r2:=round(ym / 100 * 90);
  w:=0;
  repeat
    x:=xm+round(sin(w * pi / 180) * r1);
    y:=ym+round(cos(w * pi / 180) * r1);
    test.Canvas.MoveTo(x,y);
    x:=xm+round(sin(w * pi / 180) * r2);
    y:=ym+round(cos(w * pi / 180) * r2);
    test.Canvas.LineTo(x,y);
    w:=w + 6;
  until w >= 360;


  BitBlt(test.Canvas.Handle,350,10,199,199,test.Canvas.Handle,0,0,SRCCOPY);
end;

end.
